/*************************************************************************\
|  File: Camera.c                                                         |
|                                                                         |
|  This file has functions for the Camera struct                          |
|  Copyright (C) Ulf Magnusson & Marcus Lundblad & Yuwei Zhao 1999        |
|                                                                         |
\*************************************************************************/

#include "Camera.h"
#include <stdio.h>


Camera Camera_create( Vector location,
                      Vector lookAt,
                      Vector upVector,
                      double zoom,
                      double worldWidth,
                      double worldHeight,
                      long   pixelWidth,
                      long   pixelHeight )
{
    Camera cam;
    cam.location = location;
    cam.lookAt = lookAt;
    cam.upVector = upVector;
    cam.zoom = zoom;
    cam.worldWidth = worldWidth;
    cam.worldHeight = worldHeight;
    cam.pixelWidth = pixelWidth;
    cam.pixelHeight = pixelHeight;
    return( cam );
}

void Camera_setLocation( Camera cam, Vector location )
{
    cam.location = location;
}

void Camera_setLookAt( Camera cam, Vector lookAt )
{
    cam.lookAt = lookAt;
}

void Camera_setUpVector( Camera cam, Vector upVector )
{
    cam.upVector = upVector;
}

void Camera_setZoom( Camera cam, double zoom )
{
    cam.zoom = zoom;
}

Vector Camera_location( Camera cam )
{
    return cam.location;
}

Vector Camera_lookAt( Camera cam )
{
    return cam.lookAt;
}

Vector Camera_upVector( Camera cam )
{
    return cam.upVector;
}

double Camera_zoom( Camera cam )
{
    return cam.zoom;
}

long Camera_pixelWidth( Camera cam )
{
    return cam.pixelWidth;
}

long Camera_pixelHeight( Camera cam )
{
    return cam.pixelHeight;
}

double Camera_worldWidth( Camera cam )
{
    return cam.worldWidth;
}

double Camera_worldHeight( Camera cam )
{
    return cam.worldHeight;
}


void Camera_print( Camera c )
{
    fprintf( stderr, "Camera at: " );
    Vector_print( c.location );
    fprintf( stderr, " looking at: ");
    Vector_print( c.lookAt );
    fprintf( stderr, " upvector: ");
    Vector_print( c.upVector );
    fprintf( stderr, "zoom: %f world width: %f world height 
                      %f pixel width %ld pixel height %ld\n", 
             c.zoom,
             c.worldWidth,
             c.worldHeight,
             c.pixelWidth,
             c.pixelHeight);
}
             
