/*************************************************************************\
|  File: Finish.h                                                         |
|                                                                         |
|  Defines an abstract datatype for finish used by bison parser           |
|                                                                         |
\*************************************************************************/

#ifndef FINISH_H
#define FINISH_H


#define REFLECTION_DEFAULT (double)0.0
#define DIFFUSE_DEFAULT (double)1.0

typedef struct
{
    double diffuse;
    double reflection;
} Finish;



/**************************************************************************
  Function:  Finish_create
  Arguments: 2 doubles
  Result:    Finish
  Procedure: creates a finish from diffuse and reflection
 *************************************************************************/

Finish Finish_create( double diffuse, double reflection );


/**************************************************************************
  Function:  Finish_diffuse
  Arguments: Finish
  Result:    double
  Procedure: returns the diffuse of a finish
 *************************************************************************/

double Finish_diffuse( Finish fi );


/**************************************************************************
  Function:  Finish_reflection
  Arguments: Finish
  Result:    double
  Procedure: returns the reflection of a finish
 *************************************************************************/

double Finish_reflection( Finish fi );

#endif /* FINISH_H */
