/*************************************************************************\     
|  File: Light.h                                                          |
|                                                                         |
|  Defines an abstract datatype for light sources                         |
|                                                                         |
\*************************************************************************/

#ifndef LIGHT_H
#define LIGHT_H

#include "Vector.h"

typedef struct
{
    Vector position;
} Light;



/**************************************************************************
  Function:  Light_create
  Arguments: Vector
  Result:    Light
  Procedure: create a light positioned at Vector
 *************************************************************************/

Light Light_create( Vector v );


/**************************************************************************
  Function:  Light_position
  Arguments: Light
  Result:    Vector
  Procedure: gives the position of a light
 *************************************************************************/

Vector Light_position( Light l );


/**************************************************************************
  Function:  Light_print
  Arguments: Light
  Result:    void
  Procedure: prints a light source to stderr
 *************************************************************************/

void Light_print( Light l ); 

#endif /* LIGHT_H */
