/*************************************************************************\      
|  File: Parmeters.c                                                      |
|                                                                         |
|  This file implements the ADT for trace parameters                      |
|                                                                         |
\*************************************************************************/

#include "Parameters.h"

#include <stdio.h>

Parameters Parameters_create( double zoom,
                              double world_width,
                              double world_height,
                              int pixel_width,
                              int pixel_height )
{
    /*fprintf( stderr, "Parameters: zoom %f width %f height %f\n
      xpix %d ypix %d\n", zoom, 
		      world_width,
		      world_height,
		      pixel_width,
		      pixel_height );*/

    return (Parameters) { zoom, 
                          world_width,
                          world_height,
                          pixel_width,
                          pixel_height };
}

double Parameters_zoom( Parameters p )
{
    return p.zoom;
}

double Parameters_worldWidth( Parameters p )
{
    return p.world_width;
}

double Parameters_worldHeight( Parameters p )
{
    return p.world_height;
}

int Parameters_pixelWidth( Parameters p )
{
    return p.pixel_width;
}

int Parameters_pixelHeight( Parameters p )
{
    return p.pixel_height;
}
