/*************************************************************************\
| File: Ray.c                                                             |
|                                                                         |
| This file implements the Ray ADT                                        |
|                                                                         |
\*************************************************************************/

#include <math.h>

#include "Object.h"
#include "Vector.h"
#include "Color.h"
#include "Ray.h"
#include "World.h"
#include "Pigment.h"



Ray Ray_create( Vector origin, Vector direction )
{
    return (Ray) { origin, Vector_normalize( direction ) };
}

Vector Ray_origin( Ray ray )
{
    return ray.origin;
}

Vector Ray_direction( Ray ray )
{
    return ray.direction;
}


