// test8.pov
//
// Test of projections on spheres and triangles. The resulting
// bitmap should show the pictures of three arbritrary chosen persons
// projected on triangles and a sphere with a map of earth projected
// on it.
// The specification/grammar doesn't specify in which order the
// corners in the triangle should be read (T0, T1, T2) so the result
// may vary.
//
// Tracer options: -z 1.5 -w 1 -h 1 -x 240

camera
{
  location <-46, 10, 10>
  sky <0, 1, 0>
  look_at <20, 10, 5>
}

light_source
{
  <-60, 30, 60>
}

light_source
{
  <-60, 30, -60>
}

background
{
  color rgb <0, 0, 0.3>
}

plane_point
{
  <0, 0, 0>, <0, 1, 0>
  pigment { color rgb <1, 1, 0.5> }
  finish { reflection 0.3 }
}

triangle
{
  <70, 0, 20>, <90, 0, 0>, <70, 30, 20>
  pigment { image_map { ppm "person1-inv.ppm" } }
}

triangle
{
  <90, 30, 0>, <70, 30, 20>, <90, 0, 0>
  pigment { image_map { ppm "person1.ppm" } }
}

triangle
{
  <90, 0, 0>, <70, 0, -20>, <90, 30, 0>
  pigment { image_map { ppm "person2-inv.ppm" } }
}

triangle
{
  <70, 30, -20>, <90, 30, 0>, <70, 0, -20>
  pigment { image_map { ppm "person2.ppm" } }
}

triangle
{
  <70, 0, -20>, <90, 0, -40>, <70, 30, -20>
  pigment { image_map { ppm "person3-inv.ppm" } }
}

triangle
{
  <90, 30, -40>, <70, 30, -20>, <90, 0, -40>
  pigment { image_map { ppm "person3.ppm" } }
}

sphere
{
  <200, 70, 50>, 20
  pole <0, 1, 0>
  equator <1, 0, 0>
  pigment { image_map { ppm "worldmap.ppm" } }
  finish { diffuse 0.7 }
}
